#!/usr/bin/php
<?php
define("CONNECT_TIMEOUT", 1000);
define("DATA_TIMEOUT", 1200);
define("OK", 0);
define("CONNECTION_ERROR", 1);
define("WRONG_FLAG", 5);
define("BAD_FUNCTIONALITY", 9);
define("SPECIAL_ERROR", 21);

$cmd = $argv[1];
$ip = $argv[2];
$flag = $argv[4];
$flagid =$argv[3];

$pw = ereg_replace('[^a-zA-Z0-9]', '', (base64_encode($flagid)));

if ($cmd == "store") {

	$sock = sconnect($ip, 4567);

	$res = sread($sock);
	if (!preg_match("/Hello/", $res))
		adie("store: no greeting\n", BAD_FUNCTIONALITY);

	if (!ssend($sock, "friend$flagid\n"))
		adie("store: can't write (connection closed)\n", CONNECTION_ERROR);	

	$res = sread($sock);
	if (!preg_match("/(tell|remember)/", $res))
		adie("$res | store: bad answer\n", BAD_FUNCTIONALITY);

	if (!ssend($sock, "$flag\n"))
		adie("store: can't write (connection closed)\n", CONNECTION_ERROR);
		
	while (1) {
		if ($res = sread($sock)) {
			if (preg_match("/Secret saved!/", $res))
				adie("mysecretfriend: ok\n", OK);
		}
		else
			adie("store: can't find ending\n", BAD_FUNCTIONALITY);
	}
	sclose($sock);
	
	adie("store: can't find ending\n", BAD_FUNCTIONALITY);
}

if ($cmd == "retrieve") {
	
	$sock = sconnect($ip, 4567);

	$res = sread($sock);
	if (!preg_match("/Hello/", $res))
		adie("retrieve: no greeting\n", BAD_FUNCTIONALITY);

	if (!ssend($sock, "friend$flagid\n"))
		adie("retrieve: can't write (connection closed)\n", CONNECTION_ERROR);	
	
	$res = sread($sock);
	if (!preg_match("/(remember)/", $res))
		adie("retrieve: no flag\n", BAD_FUNCTIONALITY);
	
	for ($i = 0; $i < 5; $i++) {
		if ($res = sread($sock)) {
			if (preg_match("/$flag/", $res))
				adie("mysecretfriend: ok\n", OK);
		}
		else
			adie("retrieve: wrong flags\n", BAD_FUNCTIONALITY);
	}
	sclose($sock);
	
	adie("retrieve: wrong flags\n", BAD_FUNCTIONALITY);
}

echo "No command given :O\n";
die(SPECIAL_ERROR);

function sconnect($ip, $port) {
	$s = fsockopen($ip, $port, $errno, $errstr, 20);
	if (!$s)
		adie("can't connect\n", CONNECTION_ERROR);
	stream_set_timeout($s, 40);
	return $s;
}

function ssend($s, $str) {
	return fwrite($s, $str);
}

function sread($s) {
	return fgets($s);
}

function sclose($s) {
	return fclose($s);
}

function req($uri,$method,$headers,$data,$postfile=false) {
	$cr=curl_init();
	curl_setopt($cr,CURLOPT_CONNECTTIMEOUT_MS,CONNECT_TIMEOUT);
	curl_setopt($cr,CURLOPT_TIMEOUT_MS,DATA_TIMEOUT);
	curl_setopt($cr,CURLOPT_HEADER,1);
	curl_setopt($cr,CURLOPT_POST,(strtoupper($method)=="POST"?1:0));
	curl_setopt($cr,CURLOPT_RETURNTRANSFER,1);
	curl_setopt($cr,CURLOPT_SSL_VERIFYPEER,0);
	curl_setopt($cr,CURLOPT_URL,$uri);
	if (strtoupper($method)=="POST") {
		if ($postfile) {
			$arr=array();
			foreach (explode("&",$data) as $pd) {
				list ($key,$val) = explode("=",$pd,2);
				$arr[$key]=$val;
			}
			curl_setopt($cr,CURLOPT_POSTFIELDS,$arr);
		} else
		curl_setopt($cr,CURLOPT_POSTFIELDS,$data);
	}
	curl_setopt($cr,CURLOPT_HTTPHEADER,explode("\r\n",trim($headers)));
	$result = curl_exec($cr);
	if ($result === false) {
		$errorstr = curl_error($cr);
		adie("can't connect\n", CONNECTION_ERROR);
	}
	return $result;
}

function adie($text, $code) {
	$fd = fopen('scripts/msf.log', 'a');
	fwrite($fd, $text);
	fclose($fd);
	echo $text;
	die($code);
}
?>
